## drs4eb 5.0.6%2Bgit20211217%2Bds

=== software/drsosc/Makefile ===
########################################################
#
#  Makefile for drsosc executable under linux
#
#  Requires wxWidgets 2.8.9 or newer
#
#  S. Ritt, Nov. 2016
########################################################

# determine OS
OSTYPE = $(shell uname)

# check if wxWidgets is installed
HAVE_WX       = $(shell which wx-config)
ifeq ($(HAVE_WX),)
$(error Error: wxWidgets required to compile "drsosc")
endif

CFLAGS        = -g -O2 -Wall -Wuninitialized -Wno-unused-result -Wno-deprecated-declarations -fno-strict-aliasing -DHAVE_USB -DHAVE_LIBUSB10 -DUSE_DRS_MUTEX
CFLAGS        += -I../include -I../mxml -I../ -I/usr/local/include -I/usr/local/include/libusb-1.0/
WXFLAGS       = $(shell wx-config --cxxflags)
LIBS          = -L/usr/local/lib/ -L/opt/local/lib/ -lpthread -lutil
LIBS          += $(shell wx-config --libs)

WX_OBJ        = ConfigDialog.o DOFrame.o DOScreen.o DRSOsc.o MeasureDialog.o Measurement.o Osci.o EPThread.o DisplayDialog.o InfoDialog.o AboutDialog.o TriggerDialog.o
OBJECTS       = main.o musbstd.o DRS.o rb.o averager.o mxml.o strlcpy.o $(WX_OBJ)

OUTNAME       = drsosc

# OS specific flags
ifeq ($(OSTYPE),Darwin)
CFLAGS        += -DOS_DARWIN -stdlib=libc++
LIBS          += -lusb-1.0
endif

ifeq ($(OSTYPE),Linux)
CFLAGS        += -DOS_LINUX
LIBS          += -lusb-1.0
endif

all: $(OUTNAME) read_binary
app: DRSOsc.app

$(OUTNAME): $(OBJECTS)
	$(CXX) $(CFLAGS) $(OBJECTS) -o $(OUTNAME) $(LIBS)

DRSOsc.app: drsosc
	-mkdir DRSOsc.app
	-mkdir DRSOsc.app/Contents
	-mkdir DRSOsc.app/Contents/MacOS
	-mkdir DRSOsc.app/Contents/Resources
	-mkdir DRSOsc.app/Contents/Resources/English.lproj
	echo 'APPL????' > DRSOsc.app/Contents/PkgInfo
	cp drsosc.xcodeproj/Info-processed.plist DRSOsc.app/Contents/Info.plist
	cp drsosc DRSOsc.app/Contents/MacOS/DRSOsc
	cp DRSOsc.icns DRSOsc.app/Contents/Resources

read_binary: read_binary.cpp
	$(CXX) $(CFLAGS)  -o $@ $<

main.o: %.o: %.cpp ../mxml/mxml.h ../include/DRS.h
	$(CXX) $(CFLAGS) $(WXFLAGS) -c $<

musbstd.o: ../src/musbstd.c ../include/musbstd.h
	$(CC) $(CFLAGS) -c $<

DRS.o: ../src/DRS.cpp ../include/DRS.h
	$(CXX) $(CFLAGS) $(WXFLAGS) -c $<

rb.o: rb.cpp rb.h
	$(CXX) $(CFLAGS) -c $<

averager.o: ../src/averager.cpp ../include/averager.h
	$(CXX) $(CFLAGS) -c $<

mxml.o: ../mxml/mxml.cxx ../mxml/mxml.h
	$(CXX) $(CFLAGS) -c $<

strlcpy.o: ../mxml/strlcpy.cxx ../mxml/strlcpy.h
	$(CXX) $(CFLAGS) -c $<

$(WX_OBJ): %.o: %.cpp %.h ../mxml/mxml.h ../include/DRS.h
	$(CXX) $(CFLAGS) $(WXFLAGS) -c $<

clean:
	rm -f *.o $(OUTNAME) read_binary

=== debian/changelog ===
drs4eb (5.0.6+git20211217+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #979400)

 -- Gürkan Myczko <tar@debian.org>  Mon, 01 Nov 2021 09:49:24 +0100

## drs4eb 5.0.6+git20211217+ds

=== software/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(DRS4EB)

set(CMAKE_INSTALL_PREFIX ${CMAKE_SOURCE_DIR})
message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")

add_subdirectory(drscl)
add_subdirectory(drsosc)

=== software/drscl/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

include_directories(${CMAKE_SOURCE_DIR}/include ${CMAKE_SOURCE_DIR}/mxml)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
find_package(libusb-1.0 REQUIRED)

set(SRC
   ../src/DRS.cpp
   ../src/averager.cpp
   ../src/musbstd.c
   ../mxml/mxml.cxx
   ../mxml/strlcpy.cxx)
   
add_executable(drscl ${SRC} drscl.cpp)
add_executable(drs_exam ${SRC} drs_exam.cpp)
add_executable(drs_exam_multi ${SRC} drs_exam_multi.cpp)

target_compile_options(drscl PRIVATE -DOS_LINUX -DHAVE_USB -DHAVE_LIBUSB10)
target_include_directories(drscl PRIVATE ${LIBUSB_1_INCLUDE_DIRS})
target_link_libraries(drscl ${LIBUSB_1_LIBRARIES})

target_compile_options(drs_exam PRIVATE -DOS_LINUX -DHAVE_USB -DHAVE_LIBUSB10)
target_include_directories(drs_exam PRIVATE ${LIBUSB_1_INCLUDE_DIRS})
target_link_libraries(drs_exam ${LIBUSB_1_LIBRARIES})

target_compile_options(drs_exam_multi PRIVATE -DOS_LINUX -DHAVE_USB -DHAVE_LIBUSB10)
target_include_directories(drs_exam_multi PRIVATE ${LIBUSB_1_INCLUDE_DIRS})
target_link_libraries(drs_exam_multi ${LIBUSB_1_LIBRARIES})

install(TARGETS drscl drs_exam drs_exam_multi DESTINATION bin)

=== software/drscl/Makefile ===
########################################################
#  Makefile for drscl executable under linux
#
#  S. Ritt, Nov. 2016
########################################################

# determine OS
OSTYPE = $(shell uname)

FLAGS         = -g -O3 -Wall -Wuninitialized -Wno-unused-result -DOS_LINUX
FLAGS         += -I../include -I/usr/local/include -I/usr/local/include/libusb-1.0
LIBS          = -lpthread -lutil -lusb-1.0

OBJECTS       = DRS.o averager.o musbstd.o mxml.o strlcpy.o
EXECS         = drscl drs_exam drs_exam_multi

ifeq ($(OSTYPE),Darwin)
FLAGS         += -DHAVE_USB -DHAVE_LIBUSB10
LIBS          += -framework IOKit -framework CoreFoundation -lobjc
else
FLAGS         += -DHAVE_USB -DHAVE_LIBUSB10
endif

all: $(EXECS)

drscl: $(OBJECTS) drscl.o
	$(CXX) $(FLAGS) $(OBJECTS) drscl.o -o drscl $(LIBS)

drs_exam: $(OBJECTS) drs_exam.o
	$(CXX) $(FLAGS) $(OBJECTS) drs_exam.o -o drs_exam $(LIBS)

drs_exam_multi: $(OBJECTS) drs_exam_multi.o
	$(CXX) $(FLAGS) $(OBJECTS) drs_exam_multi.o -o drs_exam_multi $(LIBS)

drscl.o: drscl.cpp ../include/DRS.h
	$(CC) $(FLAGS) -c $<

drs_exam.o: drs_exam.cpp ../include/DRS.h
	$(CC) $(FLAGS) -c $<

drs_exam_multi.o: drs_exam_multi.cpp ../include/DRS.h
	$(CC) $(FLAGS) -c $<

musbstd.o: ../src//musbstd.c ../include/musbstd.h
	$(CC) $(FLAGS) -c $<

DRS.o: ../src/DRS.cpp ../include/DRS.h
	$(CXX) $(FLAGS) -c $<

mxml.o: ../src/mxml.c ../include/mxml.h
	$(CC) $(FLAGS) -c $<

strlcpy.o: ../src/strlcpy.c ../include/strlcpy.h
	$(CC) $(FLAGS) -c $<

averager.o: ../src/averager.cpp ../include/averager.h
	$(CC) $(FLAGS) -c $<

clean:
	rm -f *.o $(EXECS)

=== software/drsosc/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

execute_process(COMMAND wx-config --cxxflags OUTPUT_VARIABLE WX_CXXFLAGS)
separate_arguments(WX_CXXFLAGS UNIX_COMMAND ${WX_CXXFLAGS})
execute_process(COMMAND wx-config --libs OUTPUT_VARIABLE WX_LIBS)
string(STRIP ${WX_LIBS} WX_LIBS)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
find_package(libusb-1.0 REQUIRED)

set(LIBSRC
   ../src/DRS.cpp
   ../src/averager.cpp
   ../src/musbstd.c
   ../mxml/mxml.cxx
   ../mxml/strlcpy.cxx)

set(SRC
   ConfigDialog
   DOFrame
   DOScreen
   DRSOsc.cpp
   MeasureDialog
   Measurement
   Osci
   EPThread
   DisplayDialog
   InfoDialog
   AboutDialog
   TriggerDialog
   rb
   main)

add_executable(drsosc ${SRC} ${LIBSRC})

target_compile_options(drsosc PRIVATE 
   -Wno-deprecated-declarations
   -DOS_LINUX -DHAVE_USB -DHAVE_LIBUSB10 -DUSE_DRS_MUTEX)
target_compile_options(drsosc PRIVATE ${WX_CXXFLAGS})

target_include_directories(drsosc PRIVATE 
   ${CMAKE_SOURCE_DIR}/include 
   ${CMAKE_SOURCE_DIR}/mxml
   ${LIBUSB_1_INCLUDE_DIRS})
target_link_libraries(drsosc ${LIBUSB_1_LIBRARIES} ${WX_LIBS})

target_link_options(drsosc PRIVATE -L/opt/local/lib)

set_target_properties(drsosc PROPERTIES
   MACOSX_BUNDLE ON
   MACOSX_BUNDLE_BUNDLE_NAME "DRSOsc"
   MACOSC_BUNDLE_BUNDLE_IDENTIFIER "PSI.DRSOsc")

install(TARGETS drsosc DESTINATION bin)

=== debian/changelog ===
drs4eb (5.0.6+git20211217+ds-5) unstable; urgency=medium

  * d/rules: ignore minimal cmake version. (Closes: #1112856)

 -- Alex Myczko <tar@debian.org>  Mon, 29 Sep 2025 09:27:37 +0200

drs4eb (5.0.6+git20211217+ds-4) unstable; urgency=medium

  * Bump standards version to 4.7.0.
  * d/copyright: fix typo.

 -- Alex Myczko <tar@debian.org>  Mon, 15 Jul 2024 21:51:20 +0000

drs4eb (5.0.6+git20211217+ds-3) unstable; urgency=medium

  * Fix for GUI glitches (sliders).
  * Bump standards version to 3.6.2.
  * Bump debhelper version to 13.
  * d/copyright: bump year.
  * d/control: update Vcs fields.

 -- Gürkan Myczko <tar@debian.org>  Tue, 23 Jan 2024 11:07:42 +0100

drs4eb (5.0.6+git20211217+ds-2) unstable; urgency=medium

  * Transition to wxwdigets3.2, update d/control: build-depends:
    libwxgtk3.0-gtk3-dev to libwxgtk3.2-dev. (Closes: #1019832)
  * Bump standards version to 3.6.1.
  * d/copyright: bump year.

 -- Gürkan Myczko <tar@debian.org>  Thu, 15 Sep 2022 09:02:26 +0200

=== debian/control ===
Source: drs4eb
Section: science
Priority: optional
Maintainer: Alex Myczko <tar@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 libwxgtk3.2-dev,
 libusb-1.0-0-dev
Standards-Version: 4.7.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/drs4eb
Vcs-Git: https://salsa.debian.org/debian/drs4eb.git
Homepage: https://www.psi.ch/en/drs/software-download

Package: drs4eb
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: DRS4 Evaluation Board software
 The DRS4 chip is a full custom Integrated Circuit developed at PSI,
 Switzerland. It contains a switched capacitor array (SCA) with 1024 cells,
 capable of digitizing eight analog signals with high speed (6 GSPS) and high
 accuracy (11.5 bit SNR) on a single chip. This web site contains the chip
 documentation and software (firmware, drivers, applications) needed in order
 to work with the chip or the chip evaluation board.
 .
 This is software that is only useful if you also get the hardware for it.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --sourcedirectory=software

override_dh_auto_install:
	@echo USING d/install

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_POLICY_VERSION_MINIMUM=3.5
